% WERNER DECONVOLUTION ALGORITHM
clear all, close all;

% INPUT OF PROFILE DATA - from 2 columns file (into matrix inpXdT)
inpXdT = dlmread('mod2.dat',' ');
% columns are separated into vectors X and dT
X=inpXdT(:,1);  dT=inpXdT(:,2);

% number of readed data-rows is determined - put into m
m = numel(X);

% plotting the graph of input data
plot(dT); xlabel('x [m]','FontSize',10); ylabel('dT[nT]','FontSize',10);

                   % operator (window) length
                     operl = 4;
                   % operator (window) length

% MAIN ALGORITHM OF WERNER DECONVOLUTION
% main cycle along the profile data - running from 1 to m-operl-1
% sol_i - order number of obtained solutions
sol_i=0;
for i=1:m-operl-1
        % creation of the matrix for 4 stages of the interpr. equation
        for k=0:operl-1
            A(k+1,1)=1; A(k+1,2)=X(i+k); A(k+1,3)=dT(i+k); A(k+1,4)=X(i+k)*dT(i+k);
        end; 
         % creation of the right-hand side vector b
         for k=0:operl-1
             b(k+1,1) = X(i+k)*X(i+k)*dT(i+k);
         end;
        % solution of the Ax = b system
        x = A\b  %Matlab black-box method
        %x = pinv(A)*b; %pseudo-inverse matrix method 
        c = cond(A);
        % number of solutions will be increased
        sol_i = sol_i + 1;

       % calculation of dike parameters x0 and z0
        x_sol0(sol_i,1) = x(4)/2;
        z_sol0(sol_i,1) = -sqrt(-x(3)-x(4)*x(4)/4);
        c_sol0(sol_i,1) = c;
        % if the solution for x0 is not in the interval of the profile,
        %     or if the solution for z0 is not pure real number, it will be not accepted
        if ( x_sol0(sol_i,1)<X(i) ) | ( x_sol0(sol_i,1)>X(i+operl-1) ) | (imag(z_sol0(sol_i,1))~=0 )
            sol_i=sol_i - 1;
        end;
 end; % end of the main cycle along the profile data,
sol_i

% plotting of solutions 
%plot(x_sol0,z_sol0)
figure, plot(x_sol0,z_sol0,'--rs','LineWidth',2,...
                'MarkerEdgeColor','k',...
                'MarkerFaceColor','g',...
                'MarkerSize',6)
grid on
axis([X(1) X(m) -30 0]); xlabel('x [m]','FontSize',10); ylabel('z[m]','FontSize',10);

% writing of determined solutions into a file
% creating a matrix from solution vectors
solXZ = [x_sol0 z_sol0 c_sol0];
save  werner_solutions.dat  solXZ  -ascii  -double;

% END OF THE SCRIPT

        
        
